# cWeapon Class Reference

Inheritance diagram for cWeapon:

List of all members.

## Public Member Functions

cWeapon (DWORD dwGUID, cLocation &Loc, DWORD dwModel, float flScale, BOOL fSolid, DWORD dwIcon, std::string strName, std::string strDescription, DWORD dwValue, WORD wWeight, BYTE bWieldType, DWORD dwIconHighlight, float fWorkmanship, DWORD dwMaterialType, DWORD dwWeaponDamage, DWORD dwWeaponSpeed, DWORD dwWeaponSkill, DWORD dwDamageType, double dWeaponVariance, double dWeaponModifier, double dWeaponPower, double dWeaponAttack)

cWeapon (DWORD dwGUID, DWORD dwContainer, DWORD dwModel, float flScale, BOOL fSolid, DWORD dwIcon, std::string strName, std::string strDescription, DWORD dwValue, WORD wWeight, BYTE bWieldType, DWORD dwIconHighlight, float fWorkmanship, DWORD dwMaterialType, DWORD dwWeaponDamage, DWORD dwWeaponSpeed, DWORD dwWeaponSkill, DWORD dwDamageType, double dWeaponVariance, double dWeaponModifier, double dWeaponPower, double dWeaponAttack)

cMessage | CreatePacket ()
cMessage | CreatePacketContainer (DWORD Container, DWORD ItemModelID)
void | Assess (cClient *pcAssesser)
void | Action (cClient *who)
DWORD | GetItemModelID ()
DWORD | GetContainerID ()
DWORD | GetItemValue ()
int | GetIsUAWeapon ()

## Public Attributes

DWORD | m_dwItemModelID
BYTE | m_bWieldType
int | isUAWeapon
DWORD | m_dwDamageType

## Protected Attributes

WORD | m_wWeight
DWORD | m_dwValue
DWORD | m_wIconHighlight
float | m_fWorkmanShip
DWORD | m_dwMaterialType
DWORD | m_dwWeaponDamage
DWORD | m_dwWeaponSpeed
DWORD | m_dwWeaponSkill
double | m_dWeaponVariance
double | m_dWeaponModifier
double | m_dWeaponPower
double | m_dWeaponAttack
BOOL | m_fIsStackable
BOOL | m_fEquippable
BOOL | m_fIsSolid
std::string | m_strDescription

## Constructor & Destructor Documentation

cWeapon::cWeapon | ( | DWORD | dwGUID,
|  | cLocation & | Loc,
|  | DWORD | dwModel,
|  | float | flScale,
|  | BOOL | fSolid,
|  | DWORD | dwIcon,
|  | std::string | strName,
|  | std::string | strDescription,
|  | DWORD | dwValue,
|  | WORD | wWeight,
|  | BYTE | bWieldType,
|  | DWORD | dwIconHighlight,
|  | float | fWorkmanship,
|  | DWORD | dwMaterialType,
|  | DWORD | dwWeaponDamage,
|  | DWORD | dwWeaponSpeed,
|  | DWORD | dwWeaponSkill,
|  | DWORD | dwDamageType,
|  | double | dWeaponVariance,
|  | double | dWeaponModifier,
|  | double | dWeaponPower,
|  | double | dWeaponAttack |
| ) |  |  | `[inline]`

A constructor.

Called whenever a weapon object is initialized in the world.

cWeapon::cWeapon | ( | DWORD | dwGUID,
|  | DWORD | dwContainer,
|  | DWORD | dwModel,
|  | float | flScale,
|  | BOOL | fSolid,
|  | DWORD | dwIcon,
|  | std::string | strName,
|  | std::string | strDescription,
|  | DWORD | dwValue,
|  | WORD | wWeight,
|  | BYTE | bWieldType,
|  | DWORD | dwIconHighlight,
|  | float | fWorkmanship,
|  | DWORD | dwMaterialType,
|  | DWORD | dwWeaponDamage,
|  | DWORD | dwWeaponSpeed,
|  | DWORD | dwWeaponSkill,
|  | DWORD | dwDamageType,
|  | double | dWeaponVariance,
|  | double | dWeaponModifier,
|  | double | dWeaponPower,
|  | double | dWeaponAttack |
| ) |  |  | `[inline]`

A constructor.

Called whenever a weapon object is initialized in a container.

## Member Function Documentation

void cWeapon::Action | ( | cClient * | who | ) | `[virtual]`

Handles the actions of weapons objects.

This function is called whenever a weapon is used or should perform an action.

Implements cObject.

void cWeapon::Assess | ( | cClient * | pcAssesser | ) | `[virtual]`

Handles the assessment of weapons objects.

This function is called whenever a weapon is assessed by a client.

Returns a Game Event (0x0000F7B0) server message of type Identify Object (0x000000C9).

Reimplemented from cObject.

cMessage cWeapon::CreatePacket | ( |  | ) | `[virtual]`

Handles the message sent for the creation of weapons in the world.

This function is called whenever a weapon should be created in the world for a client.

Returns:
  cMessage - Returns a Create Object (0x0000F745) server message.

Implements cObject.

cMessage cWeapon::CreatePacketContainer | ( | DWORD | Container,
|  | DWORD | ItemModelID |
| ) |  |  |

Handles the message sent for the creation of weapons in a container.

This function is called whenever a weapon should be created in the inventory of another object.

Returns:
  cMessage - Returns a Create Object (0x0000F745) server message.

The documentation for this class was generated from the following files:

- E:/uas2/Server/Object.h
- E:/uas2/Server/cWeapon.cpp